﻿using System;
using System.Collections.Generic;
using System.Windows.Forms;
using ElmoMotionControl.GMAS.EASComponents.MMCLibDotNET;

namespace GMAS_Lib_test
{
    public class ConnectivityData
    {
        
        public delegate void DataChange();

        public event DataChange OnDataChange;

        public ulong AsyncRequst;
        public ulong AsyncResponse;

        public bool IsCANInternal;
        private Int32 handle;
        public Int32 Handle
        {
            get { return handle; }
            set 
            {
                handle = value;
                if (handle != 0 && single != null)
                    IsValid = true;
                else
                    IsValid = false;
                
                if (OnDataChange != null)
                    OnDataChange();
            }
        }

        private MMCSingleAxis single;
        public MMCSingleAxis SingleAxis
        {
            get { return single; }
            set 
            {
                single = value;
                if (handle != 0 && single != null)
                    IsValid = true;
                else
                    IsValid = false;
                if(OnDataChange != null) OnDataChange();
            }
        }

        private MMCGroupAxis group;
        public MMCGroupAxis GroupAxis
        {
            get { return group; }
            set
            {
                group = value;
                if (handle != 0 && group != null)
                    IsValid = true;
                else
                    IsValid = false;
                if(OnDataChange != null) OnDataChange();
            }
        }

        private readonly List<String> _axesOfGroup;
        public void ClearGroupAxes()
        {
            _axesOfGroup.Clear();
        }
        public bool AddGroupAxis( String AxName )
        {
            try
            {
                _axesOfGroup.Add(AxName);
            }
            catch
            {
                return false;
            }
            return true;
        }

        public MMCSingleAxis[] GetGroupAxes( out byte count )
        {
            count = 0;
            MMCSingleAxis[] arr = new MMCSingleAxis[16];
            foreach (String axName in _axesOfGroup)
            {
                try
                {
                    arr[count] = new MMCSingleAxis(axName, Handle);
                    count++;
                }
                catch (MMCException ex)
                {
                    MessageBox.Show(ex.ToString(), "MMC Exception");
                    count = 0;

                    return null;
                }
            }
            return arr;
        }
        private bool valid;
        public bool IsValid
        {
            get { return valid; }
            private set
            {
                valid = value;
                if(OnDataChange != null) OnDataChange();
            }
        }

        private ListBox OutList;
        //private RichTextBox richTB { get; set; }

        public delegate void CrossThread(Object obj );

        public void ToOutput( Object obj )
        {
            if (OutList.InvokeRequired)
            {
                OutList.BeginInvoke(new CrossThread(ToOutput),
                    new object[] { obj });
            }
            else
            {
                String strObj = obj as String;
                if (OutList.Items.Count > 1000)
                    OutList.Items.Clear();
                OutList.Items.Add(strObj);
                OutList.SelectedIndex = OutList.Items.Count - 1;
            }
        }

        public void Show( String str, System.Drawing.Color clr )
        {
            //richTB.ForeColor = clr;
            //richTB.Text = str;
        }

        
        public ConnectivityData(ListBox listBox)
        {
            _axesOfGroup = new List<String>();
            OutList = listBox;
            
            Handle = 0;
            SingleAxis = null;
            GroupAxis = null;
            IsValid = false;
        }

        public void Default()
        {
            IsValid = false;
            IsCANInternal = true;
            Handle = 0;
            SingleAxis = null;
            GroupAxis = null;
         }
    }
}
