﻿using System;
using System.Windows.Forms;
using MMCLibDotNET_Test_2010;

namespace GMAS_Lib_test
{
    public partial class SampleForm : Form
    {
        public SampleForm()
        {
            InitializeComponent();
            cData = new ConnectivityData(listBoxOut );
            foreach( TreeNode tn in tvExample.Nodes)
            {
               if( tn.Nodes != null )
               {
                   foreach( TreeNode nd in tn.Nodes)
                       ControlSwitch(nd);
               }
               ControlSwitch(tn);
            }
        }

        private void ControlSwitch( TreeNode nd )
        {
            switch (nd.Name)
            {

                case "GetVersionNode":
                    ConnectivityControl cc = new ConnectivityControl();
                    cc.Init( cData, ConnectivityPanel );
                    nd.Tag = cc;
                    break;
                case "MonitorNode":
                    MonitorControl pc = new MonitorControl();
                    pc.Init( cData,MonitorPanel);
                    nd.Tag = pc;
                    break;
                case "MovingNode":
                    MovingControl mc = new MovingControl();
                    mc.Init(cData, MovingPanel );
                    nd.Tag = mc;
                    break;
                case "MMCConnectivityNode":
                    MainMMCControl mmc = new MainMMCControl();
                    mmc.Init( ConnectivityPanel );
                    nd.Tag = mmc;
                    break;
                case "CAMPanel":
                    LoadPanel loadPanel = new LoadPanel();
                    loadPanel.Init(cData, ManagementPanel);
                    nd.Tag = loadPanel;
                    break;
                case "GMAS Firmware":
                    DownloadControl downCtrl = new DownloadControl();
                    downCtrl.Init(cData, ManagementPanel);
                    nd.Tag = downCtrl;
                    break;
                case "GMAS Programs":
                    UserCommandControl userCmdCtrl = new UserCommandControl();
                    userCmdCtrl.Init(cData, ManagementPanel);
                    nd.Tag = userCmdCtrl;
                    break;
                case "Drive Firmware & PAL":
                    DriveFWPAL downDriveFWPALCtrl = new DriveFWPAL();
                    downDriveFWPALCtrl.Init(cData, ManagementPanel);
                    nd.Tag = downDriveFWPALCtrl;
                    break;
                case "Resource & Config":
                    ResDownload downResCtrl = new ResDownload();
                    downResCtrl.Init(cData, ManagementPanel);
                    nd.Tag = downResCtrl;
                    break;
                case "MMCManagmentNode":
                    MMCManagmentControl manc = new MMCManagmentControl();
                    manc.Init(cData, ManagementPanel);
                    nd.Tag = manc;
                    break;
                case "SingleAxisManagmentNode":
                    SingleAxisManagmentControl singleAxisManagmentControl = new SingleAxisManagmentControl();
                    singleAxisManagmentControl.Init(cData, ManagementPanel);
                    nd.Tag = singleAxisManagmentControl;
                    break;
                case "ElmoAxisSyncManagmentNode":
                    SingleAxisSyncElmoManagmentControl singleAxisSyncElmoManagmentControl = new SingleAxisSyncElmoManagmentControl();
                    singleAxisSyncElmoManagmentControl.Init(cData, ManagementPanel );
                    nd.Tag = singleAxisSyncElmoManagmentControl;
                    break;
                case "ElmoAxisManagmentNode":
                    SingleAxisElmoManagmentControl sam = new SingleAxisElmoManagmentControl();
                    sam.Init(cData, ManagementPanel);
                    nd.Tag = sam;
                    break;
                case "Send Command via SDO":
                    SingleAxisSDOControl saCtrl = new SingleAxisSDOControl();
                    saCtrl.Init(cData, ManagementPanel);
                    nd.Tag = saCtrl;
                    break;
                case "SingleAxisIOControlNode":
                    SingleAxisIOControl sIO = new SingleAxisIOControl();
                    sIO.Init(cData, ManagementPanel);
                    nd.Tag = sIO;
                    break;
                case "SingleAxisPI_VarControlNode":
                    SingleAxisPI_VarControl singleAxisPiVarControl = new SingleAxisPI_VarControl();
                    singleAxisPiVarControl.Init(cData, ManagementPanel);
                    nd.Tag = singleAxisPiVarControl;
                    break;
                case "MovingVelocityNode":
                    MovingControlVelocity mcv = new MovingControlVelocity();
                    mcv.Init(cData, MovingPanel );
                    nd.Tag = mcv;
                    break;
                case "MovingHomeNode":
                    HomingControl mh = new HomingControl();
                    mh.Init(cData, MovingPanel );
                    nd.Tag = mh;
                    break;
                case "MovingHomeNode402":
                    Homing402Control mh402 = new Homing402Control();
                    mh402.Init(cData, MovingPanel );
                    nd.Tag = mh402;
                    break;
                case "GroupMonitorNode":
                    GroupMonitorControl groupMonitorControl = new GroupMonitorControl();
                    groupMonitorControl.Init( cData, MonitorPanel );
                    nd.Tag = groupMonitorControl;
                    break;
                case "GroupMovingNode":
                    GroupMovingControl groupMovingControl = new GroupMovingControl();
                    groupMovingControl.Init(cData, MovingPanel);
                    nd.Tag = groupMovingControl;
                    break;
                case "GroupMotionParamManagmentNode":
                    GroupAxisManagmentControl groupAxisManagmentControl = new GroupAxisManagmentControl();
                    groupAxisManagmentControl.Init( cData, ManagementPanel );
                    nd.Tag = groupAxisManagmentControl;
                    break;
                case "SplineOperationsNode":
                    GroupSplineControl groupSplineControl = new GroupSplineControl();
                    groupSplineControl.Init(cData, MovingPanel);
                    nd.Tag = groupSplineControl;
                    break;
                case "NodeDS401":
                    DS401Control ds401cnt = new DS401Control();
                    ds401cnt.Init( cData, MovingPanel);
                    nd.Tag = ds401cnt;
                    break;
                case "ErrorCorrection":
                    ErrorCorrectionControl ecor = new ErrorCorrectionControl();
                    ecor.Init( cData, MovingPanel);
                    nd.Tag = ecor;
                    break;
                case "MMC Error Policy":
                    MMCErrorPolicyControl eplc = new MMCErrorPolicyControl();
                    eplc.Init(cData, ManagementPanel);
                    nd.Tag = eplc;
                    break;
                case "PVT Control":
                    PvtControl pvtctrl = new PvtControl();
                    pvtctrl.Init(cData, ManagementPanel);
                    nd.Tag = pvtctrl;
                    break;
            }
        }
        private void tvExample_AfterSelect(object sender, TreeViewEventArgs e)
        {
            if (e.Node.Tag != null)
            {
                Panel pnl = ((IParentPanel) (e.Node.Tag)).GetPanel();
                if (pnl == null)
                    return;

                if (lastNode != null)
                    lastNode.BackColor = System.Drawing.Color.White;
                e.Node.BackColor = System.Drawing.Color.DeepSkyBlue;
                lastNode = e.Node;

                if( pnl.Controls.Contains((Control)e.Node.Tag))
                    return;
                if (pnl.Controls.Count != 0)
                {
                    pnl.Controls[0].Visible = false;   
                    pnl.Controls.RemoveAt(0);
                }
                
                ((Control) (e.Node.Tag)).Visible = true;
                pnl.Controls.Add((Control) e.Node.Tag);
                
            }
        }

        private void clearToolStripMenuItem_Click(object sender, EventArgs e)
        {
            this.listBoxOut.Items.Clear();
        }

        private void listBoxOut_MouseDown(object sender, MouseEventArgs e)
        {
            //if (this.ContextMenuStrip == null)
            //    this.ContextMenuStrip = contextMenuStrip_Clear;
            //    this.ContextMenuStrip.Show();
        }

        
    }
}
